/* ***** BEGIN LICENSE BLOCK *****

 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * The Original Code is bookmarkshome
 *
 * The Initial Developer of the Original Code is Jeroen Groenenboom.
 *
 * ***** END LICENSE BLOCK ***** */

function bmhBookmarksObserverService() {
    this.NC_NS = "http://home.netscape.com/NC-rdf#";
    this.RDF_NS =  "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
    try {
	this.bmhPrefBranch = Components.classes["@mozilla.org/preferences-service;1"]
	    .getService( Components.interfaces.nsIPrefService )
	    .getBranch( "bookmarkshome." );
	var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
	    .getService( Components.interfaces.nsIRDFService );
	var bmds  = rdf.GetDataSource( "rdf:bookmarks" );
	bmds.AddObserver( this );
	dump( "observer added" );
    }
    catch( e ) {
	// if anything goes wrong don't add observer
	dump( e );
    }
}

bmhBookmarksObserverService.prototype = {
    // sets pref to dynamically create bmh page when bookmarks
    // datasource changes
onAssert: function ( aDataSource, aSource, aProperty, aTarget ) {
	      // assertion of livemark icon
	      if( aProperty.Value == this.NC_NS+"Icon" ) {
		  this.bmhPrefBranch.setBoolPref( "dynamic", true );
	      }
	  },
onUnassert: function ( aDataSource, aSource, aProperty, aTarget ) {
		if(( aProperty.Value != this.RDF_NS+"nextVal" ) && 
			! ( aProperty.Value.substr( 0, this.NC_NS.length ) == this.NC_NS )) {
		    this.bmhPrefBranch.setBoolPref( "dynamic", true );
		}
	    },
onChange: function ( aDataSource, aSource, aProperty, aOldTarget, aNewTarget ) {
	  },
onMove: function ( aDataSource, aOldSource, aNewSource, aProperty, aTarget ) {
	},
onBeginUpdateBatch: function ( aDataSource ) {
		    },
onEndUpdateBatch: function ( aDataSource ) {
		  },

	 /* nsISupports */
QueryInterface: function ( aIID ) {
		    var interfaces = [
			'nsISupports',
		    'nsIRDFObserver'
			];
		    for( var index in interfaces ) {
			if ( aIID.equals( Components.interfaces[interfaces[index]] ))
			    return this;
		    }
		    throw this.C_RESULTS['NS_ERROR_NO_INTERFACE'];
		}
}

